unit MyOOMainLoop;

interface

	const
		WT_NotMine = 'NtMe';
		WT_Generic = 'Genr';

	type
		SCType = (SCSave, SCCancel, SCDiscard);
		WObject = object
				window: dialogPtr;
				resid: integer;
				window_type: OSType;
				window_id: longInt;
				growRect: rect; { minimum/maximum rect size (for use with grow window) }
				zoomSize: point; { Optimum zoom size }
				draw_grow_icon: boolean;
				is_active: boolean;
				close_hides_window: boolean;
				last_event_modifers: integer;
				procedure JointCreate (id: integer);
				procedure Create (id: integer);
				procedure Destroy;
				procedure GetWindowPos (h: handle);
				procedure SetWindowPos (h: handle; var wasvisible: boolean);
				function SaveChanges: SCType;
				procedure DoClose;
{ DoClose checks modified things etc, then calls Destroy }
				function SetMenuBar: boolean;
				procedure SetMenus;
				function EditMenuEnabled: boolean;
				procedure SetEditMenuItem (item: integer);
				procedure DoEditMenu (item: integer);
				function DoMenuKey (er: eventRecord; ch: char): longInt;
				procedure CalculateRegion (var rgn: rgnHandle);
				function WaitForEvent (var er: eventRecord; sleep: longInt): boolean;
				procedure DoIdle;
				procedure DoDiskEvent (message: longInt);
				procedure DoSuspendResume (resume: boolean);
				procedure DoHighLevel (er: eventRecord);
				procedure DoContent (where: point);
				procedure DoKey (modifiers: integer; ch: char; code: integer);
				procedure DoSpecialKey (modifiers: integer; ch: char; code: integer);
				procedure DoAutoKey (modifiers: integer; ch: char; code: integer);
				procedure DoDrag (where: point);
				procedure DoGrow (where: point);
				procedure Zoom (code: integer);
				procedure DoZoom (where: point; code: integer);
				procedure DoGoAway (where: point);
				procedure DoUpdate;
				procedure DoMouseMoved (where: point);
				procedure DrawGrow;
				procedure DoActivateDeactivate (activate: boolean);
				procedure Resize;
				procedure Draw;
				function DoMainClick (er: eventRecord): boolean;
				function DoIsDialogEvent (er: eventRecord): boolean;
				function DoDialogSelect (er: eventRecord; var dlg: dialogPtr; var item: integer): boolean;
				function HandleSimpleEvents (er: eventRecord): boolean;
				function HandleEvents (er: eventRecord): boolean;
			end;
		DObject = object(WObject)
				ok_item, cancel_item: integer;
				handle_activate_outline: boolean;
				disable_edit_menu: boolean;
				procedure Create (id: integer);
				override;
				procedure Destroy;
				override;
				procedure SetOOOutline (def_item, user_item: integer);
				procedure DrawOutline;
				procedure DObject.DoActivateDeactivate (activate: boolean);
				override;
				function HandleEvents (er: eventRecord): boolean;
				override;
				procedure DoItem (item: integer);
				procedure DoItemWhere (er: eventRecord; item: integer);
				procedure DoCancel (modifiers: integer; ch: char; code: integer);
				procedure DoOK (modifiers: integer; ch: char; code: integer);
			end;
		DTObject = object(DObject)
				procedure SetEditMenuItem (item: integer);
				override;
				function EditMenuEnabled: boolean;
				override;
				procedure DoEditMenu (item: integer);
				override;
				function DoIsDialogEvent (er: eventRecord): boolean;
				override;
			end;

	var
		default_object: WObject;

	function GetWType (wp: windowPtr): OSType;
	function GetWObject (wp: windowPtr): WObject;
	function GetDObject (dlg: dialogPtr): DObject;
	function FrontObject: WObject;
	function IsWObjectFront (o: WObject): boolean;
	function FindWindowID (id: longInt): WObject;
	procedure InitMainLoop (dobj: DObject; domenu: procptr);
{ dobj will be used returned with window set to wp whenever GetWObject/GetDObject is called with a DA or nil window }
	procedure FinishMainLoop;
{    procedure DoMenu (themenu, theitem: integer);}
	function InForeground: boolean;

implementation

	uses
		Script, Processes, MyUtils, MyTypes, MyFMenus, BaseGlobals, MySystemGlobals, {}
		MyTEUtils, MyAssertions, MyDialogs;

	const
		titlebar_hight = 18;

	type
		WStateDataPtr = ^WStateData;
		WStateDataHandle = ^WStateDataPtr;

	const
{ from EPPC }
		kHighLevelEvent = 23;
		OOMagic = 'MyOO';

	type
		myWindowRecord = record
				thewindow: windowRecord;
				magic: OSType;
			end;
		myWindowPtr = ^myWindowRecord;
		myDialogRecord = record
				thedialog: dialogRecord;
				magic: OSType;
			end;
		myDialogPtr = ^myDialogRecord;

{ from AppleEvents }
	function AEProcessAppleEvent (theEventRecord: EventRecord): OSErr;
	inline
		$303C, $021B, $A816;

	var
		domenup: procptr;
		last_window_id: longInt;
		in_foreground: boolean;

	procedure DoMenu (themenu, theitem: integer; domenu: procptr);
	inline
		$205F, $4E90;

{$S Init}
	procedure InitMainLoop (dobj: DObject; domenu: procptr);
		var
			i: integer;
			dummy: boolean;
			dummy_er: eventRecord;
	begin
		for i := 1 to 5 do
			dummy := EventAvail(everyEvent, dummy_er);
		domenup := domenu;
		default_object := dobj;
		dobj.window := nil;
		dobj.JointCreate(0);
		last_window_id := 1;
	end;

{$S Term}
	procedure FinishMainLoop;
	begin
		dispose(default_object);
	end;

{$S}
	function InForeground: boolean;
		var
			gv: longInt;
			ourpsn, frontpsn: ProcessSerialNumber;
			front: boolean;
	begin
		if (Gestalt(gestaltOSAttr, gv) = noErr) & (BTST(gv, gestaltLaunchControl)) then begin
			if (GetCurrentProcess(ourpsn) = noErr) & (GetFrontProcess(frontpsn) = noErr) then begin
				if SameProcess(ourpsn, frontpsn, front) = noErr then
					in_foreground := front;
			end;
		end;
		InForeground := in_foreground;
	end;

	function GetWRC (wp: windowPtr): WObject;
		var
			rc: longInt;
	begin
		rc := 0;
		if (wp <> nil) & (windowPeek(wp)^.windowKind >= 0) then begin
			if ((windowPeek(wp)^.windowKind = dialogKind) & (myDialogPtr(wp)^.magic = OOMagic)) | (myWindowPtr(wp)^.magic = OOMagic) then
				rc := GetWRefCon(wp);
		end;
		if rc = 0 then begin
			default_object.window := wp;
			rc := longInt(default_object);
		end;
		GetWRC := WObject(rc);
	end;

	function GetWType (wp: windowPtr): OSType;
		var
			wo: WObject;
	begin
		wo := GetWRC(wp);
		if wo = default_object then
			GetWType := WT_NotMine
		else
			GetWType := wo.window_type;
	end;

	function GetWObject (wp: windowPtr): WObject;
	begin
		GetWObject := GetWRC(wp);
	end;

	function FindWindowID (id: longInt): WObject;
		const
			WindowList = $9D6;
		type
			WindowPtrPtr = ^WindowPtr;
		var
			w: windowPtr;
			wo: WObject;
	begin
		FindWindowID := nil;
		w := WindowPtrPtr(WindowList)^;
		while w <> nil do begin
			wo := GetWObject(w);
			if wo.window_id = id then begin
				FindWindowID := wo;
				leave;
			end;
			w := windowPtr(windowPeek(w)^.nextWindow);
		end;
	end;

	function GetDObject (dlg: dialogPtr): DObject;
	begin
		GetDObject := DObject(GetWRC(dlg));
	end;

	function FrontObject: WObject;
	begin
		FrontObject := GetWRC(FrontWindow);
	end;

	function IsWObjectFront (o: WObject): boolean;
	begin
		if o = nil then
			IsWObjectFront := false
		else if o.window = nil then
			IsWObjectFront := false
		else
			IsWObjectFront := o.window = FrontWindow;
	end;

	function WObject.SaveChanges: SCType;
		var
			a: integer;
			title: str255;
	begin
		SelectWindow(window);
		GetWTitle(window, title);
		if quitNow then
			ParamText(title, GetGlobalString(quiting_str), '', '')
		else
			ParamText(title, GetGlobalString(closing_str), '', '');
		SetCursor(arrow);
		a := Alert(save_changes_alert_id, nil);
		SaveChanges := SCType(a - 1);
	end;

	function WObject.EditMenuEnabled: boolean;
	begin
		if window = nil then
			EditMenuEnabled := false
		else
			EditMenuEnabled := windowPeek(window)^.windowKind < 0
	end;

	function WObject.SetMenuBar: boolean;
		var
			oldEditEnabled, editEnabled: boolean;
	begin
		oldEditEnabled := GetIDItemEnable(M_Edit, 0);
		editEnabled := FrontObject.EditMenuEnabled;
		if editEnabled <> oldEditEnabled then
			SetIDItemEnable(M_Edit, 0, editEnabled);
		SetMenuBar := editEnabled <> oldEditEnabled;
	end;

	procedure WObject.SetMenus;
	begin
		SetFMenus;
	end;

	procedure WObject.SetEditMenuItem (item: integer);
	begin
		if not EditMenuEnabled then
			SetIDItemEnable(M_Edit, item, false);
	end;

	procedure WObject.DoEditMenu (item: integer);
		var
			dummyb: boolean;
	begin
		if item <= 6 then
			dummyb := SystemEdit(item - 1);
	end;

	function WObject.DoMenuKey (er: eventRecord; ch: char): longInt;
		const
			kMaskVirtualKey = $0000FF00; {get virtual key from event message}
			kMaskASCII1 = $00FF0000;
			kMaskASCII2 = $000000FF; {get key from KeyTrans return}
			kKeyUpMask = $0080;
		var
			h: handle;
			virtualKey, keyCId, state, keyInfo: longInt;
			keycode: integer;
			lowchar, highchar: integer;
	begin
		if BAND(er.modifiers, optionKey) <> 0 then begin
			virtualKey := BSR(BAND(er.message, kMaskVirtualKey), 8);
			keyCode := BOR(BOR(BXOR(er.modifiers, optionKey), kKeyUpMask), virtualKey);
			state := 0;

			keyCId := GetScript(GetEnvirons(smKeyScript), smScriptKeys);
			h := GetResource('KCHR', keyCId);

			if h <> nil then begin
				HLock(h); { KeyTrans won't move memory, but lock it anyway to avoid any purgine or foolishness }
				keyInfo := KeyTrans(h^, keyCode, state);
				ReleaseResource(h);
				LowChar := BAND(keyInfo, $FF);
				HighChar := BAND(BSR(keyInfo, 16), $FF);
				if lowChar <> 0 then
					ch := chr(lowChar);
				if highChar <> 0 then
					ch := chr(highChar);
			end;
		end;
		DoMenuKey := MenuKey(ch);
	end;

	procedure WObject.CalculateRegion (var rgn: rgnHandle);
	begin
		SetCursor(arrow);
		rgn := nil;
	end;

	function WObject.WaitForEvent (var er: eventRecord; sleep: longInt): boolean;
		var
			rgn: rgnHandle;
			b: boolean;
	begin
		CalculateRegion(rgn);
		WaitForEvent := WaitNextEvent(everyEvent, er, sleep, rgn);
		if rgn <> nil then
			DisposeRgn(rgn);
	end;

	procedure WObject.DoDiskEvent (message: longInt);
		var
			pt: point;
			oe: OSErr;
	begin
		if (HiWord(message) <> noErr) then begin
			pt.h := ((screenbits.bounds.Right - screenbits.bounds.Left - 304) div 2);
			pt.v := ((screenbits.bounds.Bottom - screenbits.bounds.Top - 156) div 3);
			InitCursor;
			oe := DIBadMount(pt, message);
		end;
	end;

	procedure WObject.DoSuspendResume (resume: boolean);
	begin
		in_foreground := resume;
		if FrontWindow <> nil then begin
			FrontObject.DoActivateDeactivate(resume);
		end;
		InitCursor;
	end;

	procedure WObject.DoHighLevel (er: eventRecord);
		var
			oe: OSErr;
	begin
		if has_AppleEvents then
			oe := AEProcessAppleEvent(er);
	end;

	procedure WObject.JointCreate (id: integer); { Called for DefaultObject too! }
	begin
		if window <> nil then begin
			SetWRefCon(window, ord(self));
		end;
		close_hides_window := false;
		growRect := GetGrayRgn^^.rgnBBox;
		growRect.left := 61;
		growRect.top := 61;
		zoomSize.h := 30000;
		zoomSize.v := 30000;
		window_type := WT_Generic;
		draw_grow_icon := false;
		window_id := last_window_id;
		last_window_id := last_window_id + 1;
		resid := id;
	end;

	procedure WObject.Create (id: integer);
		var
			wp: myWindowPtr;
	begin
		wp := myWindowPtr(NewPtr(SizeOf(myWindowRecord)));
		wp^.magic := OOMagic;
		window := GetNewWindow(id, ptr(wp), POINTER(-1));
		JointCreate(id);
	end;

	procedure WObject.Destroy;
	begin
		if window <> nil then
			DisposeWindow(window);
		if self <> default_object then
			dispose(self);
	end;

	type
		savedWindowRecord = record
				windowpos: rect; { the window position }
				windowvis: rect; { the visible part of the title bar }
				zoomed: boolean;
				visible: boolean;
			end;
		savedWindowPtr = ^savedWindowRecord;
		savedWindowHandle = ^savedWindowPtr;

	procedure WObject.GetWindowPos (h: handle);
		var
			rgn: RgnHandle;
			r1, r2: rect;
	begin
		HUnlock(h);
		SetHandleSize(h, SizeOf(savedWindowRecord));
		HLock(h);
		with savedWindowHandle(h)^^ do begin
			SetPort(window);
			visible := windowPeek(window)^.visible;
			windowpos := window^.portRect;
			LocalToGlobal(windowpos.topleft);
			LocalToGlobal(windowpos.botright);
			windowpos.top := windowpos.top - titlebar_hight; { title bar }
			rgn := NewRgn;
			RectRgn(rgn, windowpos);
			SectRgn(GetGrayRgn, rgn, rgn);
			windowvis := rgn^^.rgnBBox;
			DisposeRgn(rgn);
			zoomed := false;
			r1 := window^.portRect;
			LocalToGlobal(r1.topLeft);
			LocalToGlobal(r1.botRight);
			r2 := WStateDataHandle(WindowPeek(window)^.dataHandle)^^.stdState;
			InsetRect(r1, -7, -7);
			zoomed := PtInRect(r2.topLeft, r1) and PtInRect(r2.botRight, r1);
		end;
		HUnlock(h);
	end;

	procedure WObject.SetWindowPos (h: handle; var wasvisible: boolean);
		var
			rgn: RgnHandle;
			r: rect;
			dummy: boolean;
	begin
		if (h <> nil) & (GetHandleSize(h) = SizeOf(savedWindowRecord)) then begin
			HLock(h);
			with savedWindowHandle(h)^^ do begin
				wasvisible := visible;
				rgn := NewRgn;
				RectRgn(rgn, windowvis);
				SectRgn(GetGrayRgn, rgn, rgn);
				r := rgn^^.rgnBBox;
				DisposeRgn(rgn);
				dummy := SectRect(r, windowvis, r);
				if (longInt(r.topleft) = longInt(windowvis.topleft)) & (longInt(r.botright) = longInt(windowvis.botright)) then begin
					with windowpos do begin
						MoveWindow(window, left, top + titlebar_hight, true);
						SizeWindow(window, right - left, bottom - top - titlebar_hight, true);
					end;
				end;
				if zoomed then
					Zoom(inZoomOut)
				else
					Resize;
			end;
			HUnlock(h);
		end
		else
			wasvisible := true;
	end;

	procedure WObject.DoClose;
	begin
		if close_hides_window then
			HideWindow(window)
		else
			Destroy;
	end;

	procedure WObject.DoContent (where: point);
	begin
	end;

	procedure WObject.DoKey (modifiers: integer; ch: char; code: integer);
	begin
		SysBeep(1);
	end;

	procedure WObject.DoSpecialKey (modifiers: integer; ch: char; code: integer);
		var
			item: integer;
	begin
		item := -1;
		if not system7 then begin
			case code of
				undoKey: 
					item := EMundo;
				cutKey: 
					item := EMcut;
				copyKey: 
					item := EMcopy;
				pasteKey: 
					item := EMpaste;
				clearKey: 
					item := EMclear;
				otherwise
					;
			end;
		end;
		if item <> -1 then begin
			SetMenus;
			if not GetIDItemEnable(M_Edit, 0) or not GetIDItemEnable(M_Edit, item) then
				item := -1;
		end;
		if item = -1 then
			DoKey(modifiers, ch, code)
		else
			DoMenu(M_Edit, item, domenup);
	end;

	procedure WObject.DoAutoKey (modifiers: integer; ch: char; code: integer);
	begin
	end;

	procedure WObject.DoDrag (where: point);
		var
			temprect: rect;
			bnds1, bnds2: point;
	begin
		tempRect := GetGrayRgn^^.rgnBBox;
		bnds1 := window^.portBits.bounds.topleft;
		DragWindow(window, where, tempRect);
		bnds2 := window^.portBits.bounds.topleft;
		OffsetRect(WStateDataHandle(WindowPeek(window)^.dataHandle)^^.stdState, bnds1.h - bnds2.h, bnds1.v - bnds2.v);
	end;

	procedure WObject.DoGrow (where: point);
		var
			mypt: point;
			oldrect: rect;
			mResult: longInt;
			tempRect: rect;
	begin
		SetPort(window);
		myPt := where;
		GlobalToLocal(myPt);
		oldrect := window^.portRect;
		mResult := GrowWindow(window, where, growRect);
		SizeWindow(window, LoWord(mResult), HiWord(mResult), TRUE);
		SetRect(tempRect, 0, myPt.v - 15, myPt.h + 15, myPt.v + 15);
		EraseRect(tempRect);
		InvalRect(tempRect);
		SetRect(tempRect, myPt.h - 15, 0, myPt.h + 15, myPt.v + 15);
		EraseRect(tempRect);
		InvalRect(tempRect);
		Resize;
	end;

	procedure WObject.Zoom (code: integer);
		var
			globalPortRect, theSect, zoomRect: Rect;
			nthDevice, dominantGDevice: GDHandle;
			sectFlag: boolean;
			bias: integer;
			greatestArea, sectArea: longInt;
			tl, br: point;
	begin
		SetPort(window);
		EraseRect(window^.portRect);    {recommended for cosmetic reasons}
		if (code = inZoomOut) then begin
			if has_colorQD then begin
				globalPortRect := window^.portRect;
				LocalToGlobal(globalPortRect.topLeft);
				LocalToGlobal(globalPortRect.botRight);
          { must calculate height of window's title bar }
		{ bias := globalPortRect.top - 1 - WindowPeek(window)^.strucRgn^^.rgnBBox.top; }
		{   This doesn't work if the window is invisible, because structRgn is empty, and thus rgnBBox is 0,0,0,0 }
				bias := titlebar_hight;
				nthDevice := GetDeviceList;
				greatestArea := -1;
          { This loop checks the window against all the gdRects in the   }
          { gDevice list and remembers which gdRect contains the largest }
          { portion of the window being zoomed. }
				while nthDevice <> nil do begin
					sectFlag := SectRect(globalPortRect, nthDevice^^.gdRect, theSect);
					with theSect do
						sectArea := LONGINT(right - left) * (bottom - top);
					if sectArea > greatestArea then begin
						greatestArea := sectArea;
						dominantGDevice := nthDevice;
					end;
					nthDevice := GetNextDevice(nthDevice);
				end; {of WHILE}
          { We must create a zoom rectangle manually in this case. }
          { account for menu bar height as well, if on main device }
				if dominantGDevice = GetMainDevice then
					bias := bias + GetMBarHeight;
				with dominantGDevice^^.gdRect do
					SetRect(zoomRect, left + 3, top + bias + 3, right - 3, bottom - 3);
			end {of Color QuickDraw conditional stuff}
			else begin
				zoomRect := WStateDataHandle(WindowPeek(window)^.dataHandle)^^.stdState;
			end;
			tl := window^.portRect.topleft;
			LocalToGlobal(tl);
			br.v := tl.v + zoomSize.v;
			br.h := tl.h + zoomSize.h;
			with zoomRect do begin
				if PtInRect(tl, zoomRect) and PtInRect(br, zoomRect) then begin
					zoomRect.topleft := tl;
					zoomRect.botright := br;
				end
				else begin
					if right - left > zoomSize.h then
						right := left + zoomSize.h;
					if bottom - top > zoomSize.v then
						bottom := top + zoomSize.v;
				end;
			end;
       { Set up the WStateData record for this window. }
			WStateDataHandle(WindowPeek(window)^.dataHandle)^^.stdState := zoomRect;
		end;
		ZoomWindow(window, code, true);
		Resize;
	end;

	procedure WObject.DoZoom (where: point; code: integer);
	begin
		SetPort(window);
		if TrackBox(window, where, code) then
			Zoom(code);
	end;

	procedure WObject.DoGoAway (where: point);
	begin
		if TrackGoAway(window, where) then
			DoClose;
	end;

	procedure WObject.DoUpdate;
		var
			r: rect;
	begin
		BeginUpdate(window);
		Draw;
		EndUpdate(window);
	end;

	procedure WObject.DoMouseMoved (where: point);
	begin
	end;

	procedure WObject.DrawGrow;
	begin
		DrawGrowIcon(window);
	end;

	procedure WObject.DoActivateDeactivate (activate: boolean);
	begin
		Assert(window <> nil);
		is_active := activate and windowPeek(window)^.visible;
		if is_active then
			SelectWindow(window);
		if draw_grow_icon then
			DrawGrow;
	end;

	procedure WObject.Resize;
	begin
		if draw_grow_icon then
			DrawGrow;
	end;

	procedure WObject.Draw;
	begin
		if draw_grow_icon then
			DrawGrow;
	end;

	function WObject.DoIsDialogEvent (er: eventRecord): boolean;
	begin
		DoIsDialogEvent := IsDialogEvent(er);
	end;

	function WObject.DoDialogSelect (er: eventRecord; var dlg: dialogPtr; var item: integer): boolean;
	begin
		DoDialogSelect := DialogSelect(er, dlg, item);
	end;

	procedure WObject.DoIdle;
	begin
	end;

	function WObject.DoMainClick (er: eventRecord): boolean;
		var
			b: boolean;
			wp: windowPtr;
			mResult: longInt;
			code: integer;
	begin
		b := false;
		code := FindWindow(er.where, wp);
		if (wp <> nil) and (wp <> window) then begin
			if (BAND(er.modifiers, cmdKey) = 0) or (code <> inDrag) then
				SelectWindow(wp);
			if code = inDrag then
				GetWObject(wp).DoDrag(er.where);
		end
		else
			case code of
				inMenuBar:  begin
					SetMenus;
					mResult := MenuSelect(er.where);
					if mResult <> 0 then
						DoMenu(HiWord(mResult), LoWord(mResult), domenup);
				end;
				InDrag: 
					DoDrag(er.where);
				inGrow: 
					DoGrow(er.where);
				inZoomIn, inZoomOut: 
					DoZoom(er.where, code);
				inGoAway: 
					DoGoAway(er.where);
				inContent:  begin
					GlobalToLocal(er.where);
					DoContent(er.where);
				end;
				inSysWindow: 
					SystemClick(er, window);
				otherwise
					b := true;
			end;
		DoMainClick := b;
	end;

	function WObject.HandleSimpleEvents (er: eventRecord): boolean;
		var
			b: boolean;
			ch: char;
			mResult: longInt;
	begin
		last_event_modifers := er.modifiers;
		b := false;
		case er.what of
			MouseDown: 
				b := DoMainClick(er);

			KeyDown:  begin
				ch := chr(BAND(er.message, CharCodeMask));
				mResult := 0;
				if BAND(er.modifiers, CmdKey) <> 0 then begin
					SetMenus;
					mResult := DoMenuKey(er, ch);
				end;
				if mResult <> 0 then
					DoMenu(HiWord(mResult), LoWord(mResult), domenup)
				else
					DoSpecialKey(er.modifiers, ch, BAND(er.message, keyCodeMask) div $100);
			end;

			AutoKey: 
				DoAutoKey(er.modifiers, chr(BAND(er.message, CharCodeMask)), BAND(er.message, keyCodeMask) div $100);

			UpdateEvt: 
				GetWObject(windowPtr(er.message)).DoUpdate;

			ActivateEvt: 
				GetWObject(windowPtr(er.message)).DoActivateDeactivate(odd(er.modifiers));

			kOSEvent: 
				if BAND(BROTL(er.message, 8), $FF) = kSuspendResumeMessage then begin
					DoSuspendResume(BAnd(er.message, kResumeMask) <> 0);
				end
				else if BAND(BROTL(er.message, 8), $FF) = kMouseMovedMessage then begin
					DoMouseMoved(er.where);
				end
				else begin
					b := true;
				end;

			kHighLevelEvent: 
				DoHighLevel(er);

			DiskEvt: 
				DoDiskEvent(er.message);

			otherwise
				b := true;
		end;
		HandleSimpleEvents := b;
	end;

	function WObject.HandleEvents (er: eventRecord): boolean;
		var
			b: boolean;
			dlg: dialogPtr;
			item: integer;
	begin
		last_event_modifers := er.modifiers;
		DoIdle;
		b := true;
		if DoIsDialogEvent(er) then begin
			if DoDialogSelect(er, dlg, item) then begin
				GetDObject(dlg).DoItemWhere(er, item);
				b := false;
			end;
		end;
		if b then begin
			b := HandleSimpleEvents(er);
		end;
		HandleEvents := b;
	end;

	procedure DObject.Create (id: integer);
		var
			wp: myDialogPtr;
	begin
		disable_edit_menu := false;
		wp := myDialogPtr(NewPtr(SizeOf(myDialogRecord)));
		wp^.magic := OOMagic;
		window := GetNewDialog(id, ptr(wp), POINTER(-1));
		ok_item := 0;
		cancel_item := 0;
		handle_activate_outline := false;
		JointCreate(id);
	end;

	procedure DObject.Destroy;
	begin
		if window <> nil then
			DisposDialog(window);
		if self <> default_object then
			dispose(self);
	end;

	procedure OODrawOutline (dp: dialogPtr; item: integer);
		var
			r: rect;
			fi: DObject;
			pstate: PenState;
	begin
		SetPort(dp);
		GetPenState(pstate);
		fi := DObject(GetWObject(dp));
		GetDItemRect(dp, fi.ok_item, r);
		InsetRect(r, -4, -4);
		PenSize(3, 3);
		if not ControlEnabled(dp, fi.ok_item) or not fi.is_active then begin
			PenPat(gray);
			FrameRoundRect(r, 16, 16);
			PenPat(black);
		end
		else
			FrameRoundRect(r, 16, 16);
		SetPenState(pstate);
	end;

	procedure DObject.DrawOutline;
	begin
		OODrawOutline(window, ok_item);
	end;

	procedure DObject.SetOOOutline (def_item, user_item: integer);
		var
			kind: integer;
			h: handle;
			r: rect;
	begin
		handle_activate_outline := true;
		ok_item := def_item;
		GetDItem(window, user_item, kind, h, r);
		InsetRect(r, -10, -10);
		SetDItem(window, user_item, userItem, handle(@OODrawOutline), r);
	end;

	procedure DObject.DoActivateDeactivate (activate: boolean);
	begin
		inherited DoActivateDeactivate(activate);
		if handle_activate_outline then
			OODrawOutline(window, 0);
	end;

	procedure DObject.DoOK (modifiers: integer; ch: char; code: integer);
	begin
		if ok_item = 0 then
			DoKey(modifiers, ch, code)
		else begin
			if ControlEnabled(window, ok_item) then begin
				FlashItem(window, ok_Item);
				DoItem(ok_item);
			end;
		end;
	end;

	procedure DObject.DoCancel (modifiers: integer; ch: char; code: integer);
	begin
		if cancel_item = 0 then
			DoKey(modifiers, ch, code)
		else begin
			FlashItem(window, cancel_Item);
			DoItem(cancel_item);
		end;
	end;

	procedure DObject.DoItem (item: integer);
	begin
	end;

	procedure DObject.DoItemWhere (er: eventRecord; item: integer);
	begin
		DoItem(item);
	end;

	function DObject.HandleEvents (er: eventRecord): boolean;
		var
			b: boolean;
			ch: char;
	begin
		b := true;
		if ((er.what = KeyDown) or (er.what = AutoKey)) then begin
			b := false;
			ch := chr(BAND(er.message, charCodeMask));
			if (ch = chr(13)) or (ch = chr(3)) then
				DoOK(er.modifiers, ch, BAND(er.message, keyCodeMask) div $100)
			else if (ch = chr(27)) or ((ch = '.') and (BAND(er.modifiers, cmdKey) <> 0)) then
				DoCancel(er.modifiers, ch, BAND(er.message, keyCodeMask) div $100)
			else
				b := true;
		end;
		if b then
			b := inherited HandleEvents(er);
		HandleEvents := b;
	end;

	procedure DTObject.SetEditMenuItem (item: integer);
	begin
		if disable_edit_menu then
			SetIDItemEnable(M_Edit, item, false)
		else
			TESetEditMenuItem(dialogPeek(window)^.textH, false, 250, item);
	end;

	function DTObject.EditMenuEnabled: boolean;
	begin
		if disable_edit_menu then
			EditMenuEnabled := false
		else
			EditMenuEnabled := TEEditMenuEnabled(dialogPeek(window)^.textH, false, 250);
	end;

	procedure DTObject.DoEditMenu (item: integer);
		var
			modified: boolean;
	begin
		modified := TEDoEditMenu(dialogPeek(window)^.textH, false, 250, item);
	end;

	function DTObject.DoIsDialogEvent (er: eventRecord): boolean;
	begin
		if ((er.what = keyDown) or (er.what = autoKey)) and (BAND(er.modifiers, cmdKey) <> 0) then begin
			DoIsDialogEvent := false; { Stop system 7 from doing the edit menu as well }
		end
		else
			DoIsDialogEvent := inherited DoIsDialogevent(er);
	end;

end.